# -*- coding: utf-8 -*- 
"""
test de chargement et de manipulation de fichier pickle
de la base de mots-clef

"""
from os import path as osp
from os import unlink

import autopath

from filtrage.db import *
from filtrage.guesser import train_guesser


KEYWORDS = ['noporn', 'porn']
DATA = osp.join(autopath.HERE, 'data')
TRAIN_DB = osp.join(DATA, 'training')
BAYES_DB = osp.join(DATA,'bayesdb', 'guesser.bay')

def init_database():
    """creation des bases bayesiennes (fichiers en .bay)
    définies par les mots-clef
    """
    train_guesser(keywords=KEYWORDS, filename=BAYES_DB, guess_data=TRAIN_DB,
                  mode='meta')
    assert osp.isfile(BAYES_DB)

def rm_database():
    "suppression des fichiers de bases baysiennes"
    unlink(BAYES_DB)

def test_load_pickle_file():
    """creation des bases bayesiennes (fichiers en .bay)
    définies par les mots-clef
    """
    init_database()
    assert osp.isfile(BAYES_DB)
    d = load_pickle(BAYES_DB)
    assert d.keys() == KEYWORDS

def test_add_to_pickle():
    init_database()
    assert osp.isfile(BAYES_DB)
    d = load_pickle(BAYES_DB)
    assert not d['porn'].has_key('testkeyword')
    assert add_pickle('porn', ('testkeyword', 44), filename=BAYES_DB)
    d = load_pickle(BAYES_DB)
    assert d['porn']['testkeyword'] == 44

def test_del_to_pickle():

    init_database()
    assert osp.isfile(BAYES_DB)
    # ajout du mot-clef à enlever après
    assert add_pickle('porn', ('testkeyword', 44), filename=BAYES_DB)
    assert del_pickle('porn', 'testkeyword', filename=BAYES_DB)
    d = load_pickle(BAYES_DB)
    assert not d['porn'].has_key('testkeyword')
